#! /usr/bin/env python
# Ici on met tout ce qui n'a rien à faire ailleurs et qui est trop petit pour avec sa propre place!


# ----------------------------------------
# Pour les chaines de caractères

import unicodedata

def normalise_str(chaine):
    """ renvoie un chaine ou ù on a enlevé les majuscules et les accents de la chaine
    
    Arguments:
    - `chaine`:
    """
    return unicodedata.normalize('NFKD', chaine).encode('ASCII', 'ignore').lower()



# ----------------------------------------
# Les listes des lecons


liste_lecon = ( 101  , 103  , 104  , 105  , 106  , 107  , 108  , 109  , 110  , 111  , 112  , 113  , 114  , 116  , 117  , 119  , 120  , 123  , 124  , 125  , 126  , 127  , 128  , 130  , 131  , 132  , 133  , 135  , 136  , 137  , 139  , 140  , 141  , 144  , 145  , 146  , 148  , 149  , 201  , 202  , 203  , 204  , 205  , 206  , 207  , 208  , 213  , 214  , 215  , 216  , 217  , 218  , 219  , 220  , 221  , 223  , 224  , 226  , 228  , 229  , 230  , 232  , 234  , 235  , 236  , 238  , 239  , 240  , 241  , 242  , 243  , 245  , 246  , 247  , 249  , 250  , 251  , 252  , 253  , 254  , 255  , 256 )

dico_nom_lecon = { '101' : "Groupe opérant sur un ensemble. Exemples et applications."  , '103' : "Exemples et applications des notions de sous-groupe distingué et de groupes quotient."  , '104' : "Groupes finis. Exemples et applications."  , '105' : "Groupe des permutations d'un ensemble fini. Applications."  , '106' : "Groupe linéaire d'un espace vectoriel de dimension finie E, sous-groupes de GL(E). Applications"  , '107' : "Représentations et caractères des groupes finis sur un espace vectoriel complexe"  , '108' : "Exemples de parties génératrices d'un groupe. Applications."  , '109' : "Anneau Z/nZ. Applications."  , '110' : "Nombres premiers. Applications."  , '111' : "Anneaux principaux. Applications"  , '112' : "Corps finis. Applications."  , '113' : "Groupe des nombres complexes de module 1. Sous-groupes des racines de l'unité. Applications."  , '114' : "Anneau des séries formelles. Applications"  , '116' : "Polynômes irréductibles à une indéterminée. Corps de rupture. Exemples et applications."  , '117' : "Algèbre des polynômes à plusieurs inderterminées; aspects théoriques et applications"  , '119' : "Exemples d'actions de groupes sur les espaces de matrices"  , '120' : "Dimension d'un espace vectoriel (on se limitera au cas de dimension finie). Rang. Exemples et applications."  , '123' : "Déterminant. Exemples et applications."  , '124' : "Polynôme d'endomorphismes en dimension finie. Applications à la réduction d'un endomorphisme en dimension finie."  , '125' : "Sous-espaces stables d'un endomorphisme ou d'une famille d'endomorphisme d'un espace vectoriel de dimension finie. Applications."  , '126' : "Endomorphismes diagonalisables en dimension finie"  , '127' : "Exponentielle de matrices. Applications."  , '128' : "Endomorphismes trigonalisables. Endomorphismes nilpotents."  , '130' : "Matrices symétriques réelles, matrices hermitiennes."  , '131' : "Formes quadratiques sur un espace vectoriel de dimension finie. Orthogonalité, isotropie. Applications"  , '132' : "Formes linéaires et hyperplans en dimension finie. Exemples et applications."  , '133' : "Endomorphismes remarquables d'un espace vectoriel euclidien de dimension finie."  , '135' : "Isométries d'un espace affine euclidien de dim finie. Formes réduites. Applications en dim 2 et 3."  , '136' : "Coniques. Applications."  , '137' : "Barycentres dans un espace affine réel de dimension finie, convexité. Applications"  , '139' : "Application des nombres complexes à la géométrie"  , '140' : "Systèmes linéaires;opérations, aspects algorithmiques et conséquences théoriques"  , '141' : "Utilisation des groupes en géométrie."  , '144' : "Problèmes d'angles et de distances en dimension 2 ou 3."  , '145' : "Méthodes combinatoires, problèmes de dénombrement."  , '146' : "Résultant. Applications"  , '148' : "Formes quadratiques réelles. Exemples et applications."  , '149' : "Représentations des groupes finis de petit cardinal"  , '201' : "Espaces de fonctions. Exemples et applications."  , '202' : "Exemples de parties denses et applications."  , '203' : "Utilisation de la notion de compacité."  , '204' : "Connexité. Exemples et applications."  , '205' : "Espaces complets. Exemples et applications."  , '206' : "Théorèmes de point fixe. Exemples et applications."  , '207' : "Prolongement de fonctions. Exemples et applications."  , '208' : "Espaces vectoriels normés, applications linéaires continues . Exemples"  , '213' : "Espaces de Hilbert, bases hilbertiennes. Exemples et applications."  , '214' : "Théorème d'inversion locale, théorème des fonctions implicites. Exemples et applications."  , '215' : "Applications différentiables définies sur un ouvert de Rn. Exemples et applications."  , '216' : "Etude métrique des courbes. Exemples"  , '217' : "Sous-variétés de Rn, exemples"  , '218' : "Applications des formules de Taylor."  , '219' : "Problèmes d'extremum."  , '220' : "Equations différentielles X ' = f(t, X), exemples d'études qualitatives des solutions."  , '221' : "Equations différentielles linéaires. Systèmes d'équations différentielles linéaires. Exemples et applications."  , '223' : "Convergence des suites numériques. Exemples et applications."  , '224' : "Comportement asymptotique des suites numériques. Rapidité de convergence. Exemples."  , '226' : "Comportement d'une suite réelle ou vectorielle définie par une itération un+1 = f (un). Exemples."  , '228' : "Continuité et dérivabilité des fonctions réelles d'une variable réelle. Exemples et contrexemples."  , '229' : "Fonctions monotones. Fonctions convexes. Exemples et applications."  , '230' : "Séries de nombres réels ou complexes. Comportement des restes ou des sommes partielles des séries numériques. Exemples."  , '232' : "Méthodes d'approximation des solutions d'une équation F(X) = 0. Exemples."  , '234' : "Espaces Lp."  , '235' : "Suites et séries de fonctions intégrables. Exemples et applications."  , '236' : "Illustrer par des exemples quelques méthodes de calcul d'intégrales de fonctions d'une ou plusieurs variables réelles."  , '238' : "Méthodes de calcul approché d'intégrales et d'une solution d'équation différentielle."  , '239' : "Fonctions définies par une intégrale dépendant d'un paramètre. Exemples et applications"  , '240' : "Transformation de Fourier, produit de convolution. Applications."  , '241' : "Suites et Séries de fonctions. Exemples et contre-exemples."  , '242' : "Utilisation en probabilités des transformations de Fourier ou de Laplace et du produit de convolution"  , '243' : "Convergence des séries entières, propriétés de la somme. Exemples et applications."  , '245' : "Fonctions holomorphes et méromorphes sur un ouvert de C."  , '246' : "Séries de Fourier. Exemples et applications."  , '247' : "Exemples de problèmes d'interversion de limites."  , '249' : "Suites de variables de Bernoulli indépendantes."  , '250' : "Loi des grands nombres, théorème de la limite centrale. Applications."  , '251' : "Indépendance d'événements et de variables aléatoires. Exemples."  , '252' : "loi binomiale, loi de Poisson - Applications"  , '253' : "Utilisation de la notion de convexité en analyse."  , '254' : "Espace de Schwartz et distributions tempérées."  , '255' : "Dérivation au sens des distributions . Exemples et applications."  , '256' : "Transformation de Fourier dans S(Rd) et S'(Rd)." }
